#ifndef HASHTYPES_H
#define HASHTYPES_H

#include"entry.h"

#include<stddef.h>

#ifndef HASH_FN_T
#define HASH_FN_T
typedef int (* hash_fn)(key_t key,size_t size);
#endif

#ifndef SYNONYM_T
#define SYNONYM_T
typedef struct synonym {
       struct entry entry;
       struct synonym *next,*prev;
} * synonym_t;
#endif

#define SYNONYMSIZE (sizeof(struct synonym))

struct closedparam {
       hash_fn rehash;
       double occupancy;
};

struct closedptr {
         int pos, null;
};

struct openptr {
      int pos;
      synonym_t curr;
};

enum hashtabletype { OPEN, CLOSED };
enum openhashtype { UNORDERED, ORDERED = 128 };
enum closedhashtype { KEY, POS  = 128 };

#endif
